Debian Bug report logs - #489340
errno not propagated when link up fails.

version graph

Package: linux-2.6; Maintainer for linux-2.6 is Debian Kernel Team <debian-kernel@lists.debian.org>;

Reported by: Johannes Berg <johannes@sipsolutions.net>

Date: Sat, 5 Jul 2008 04:39:01 UTC

Severity: normal

Tags: fixed-upstream, patch

Fixed in version linux-2.6/2.6.28-1

Done: maximilian attems <maks@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
New Bug report received and forwarded. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: /sbin/ip: fails to check error codes
Date: Sat, 05 Jul 2008 06:36:52 +0200
Package: iproute
Version: 20080417-1
Severity: normal
File: /sbin/ip

# ip link
11: wlan0: <BROADCAST,MULTICAST> mtu 1500 qdisc pfifo_fast state DOWN qlen 1000
    link/ether 00:11:24:ij:kl:mn brd ff:ff:ff:ff:ff:ff
# ip link set wlan0 up
# ip link
11: wlan0: <BROADCAST,MULTICAST> mtu 1500 qdisc pfifo_fast state DOWN qlen 1000
    link/ether 00:11:24:ij:kl:mn brd ff:ff:ff:ff:ff:ff
# ifconfig wlan0 up
SIOCSIFFLAGS: Link has been severed
# ip link
11: wlan0: <BROADCAST,MULTICAST> mtu 1500 qdisc pfifo_fast state DOWN qlen 1000
    link/ether 00:11:24:ij:kl:mn brd ff:ff:ff:ff:ff:ff

Note that there's no output after the second command.

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.26-rc8-wl-dirty (PREEMPT)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages iproute depends on:
ii  libc6                         2.7-12     GNU C Library: Shared libraries
ii  libdb4.6                      4.6.21-10  Berkeley v4.6 Database Libraries [

Versions of packages iproute recommends:
ii  libatm1                       2.4.1-17.2 shared library for ATM (Asynchrono

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #10 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Sat, 05 Jul 2008 13:04:12 +0200
Hello Johannes!

Do you have any hints for me on how I can make my wlan0 (ath5k) fail
link up commands?

On lör, 2008-07-05 at 06:36 +0200, Johannes Berg wrote:
> # ip link set wlan0 up

I think I've found the right place in the code, but could you please do
a echo $? after the above command to see if the exit code is 2?

ip/iplink.c, line 366 (in iplink_modify):

        if (rtnl_talk(&rth, &req.n, 0, 0, NULL, NULL, NULL) < 0)
                exit(2);


There should probably be an error message before the exit function...


-- 
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #15 received at 489340@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Andreas Henriksson <andreas@fatal.se>
Cc: 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Sat, 05 Jul 2008 13:48:05 +0200
[Message part 1 (text/plain, inline)]
Hi,

> Do you have any hints for me on how I can make my wlan0 (ath5k) fail
> link up commands?

Sure, that's easy:

ip link set wlan0 down
iwconfig wlan0 mode repeater # set WDS mode but no peer address
ip link set wlan0 up

> On lör, 2008-07-05 at 06:36 +0200, Johannes Berg wrote:
> > # ip link set wlan0 up
> 
> I think I've found the right place in the code, but could you please do
> a echo $? after the above command to see if the exit code is 2?
> 
> ip/iplink.c, line 366 (in iplink_modify):
> 
>         if (rtnl_talk(&rth, &req.n, 0, 0, NULL, NULL, NULL) < 0)
>                 exit(2);
> 
> 
> There should probably be an error message before the exit function...

Heh, looks like.

johannes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #20 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Sat, 05 Jul 2008 14:19:31 +0200
On lör, 2008-07-05 at 13:48 +0200, Johannes Berg wrote:
> ip link set wlan0 down
> iwconfig wlan0 mode repeater # set WDS mode but no peer address
> ip link set wlan0 up

Unfortunately, this failed on both my atheros- and intel-based wlan that
I have available... anyway, thanks for confirming.

This command will uncover alot of places where error messages should
likely be added:


grep -R -A1 'if.*rtnl_' . | grep -B1 exit


I'll have a look at it and send the patch upstream after my upcoming
roadtrip, unless someone else has already beaten me to it by then.


-- 
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #25 received at 489340@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Andreas Henriksson <andreas@fatal.se>
Cc: 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Sat, 05 Jul 2008 14:31:02 +0200
[Message part 1 (text/plain, inline)]
On Sat, 2008-07-05 at 14:19 +0200, Andreas Henriksson wrote:
> On lör, 2008-07-05 at 13:48 +0200, Johannes Berg wrote:
> > ip link set wlan0 down
> > iwconfig wlan0 mode repeater # set WDS mode but no peer address
> > ip link set wlan0 up
> 
> Unfortunately, this failed on both my atheros- and intel-based wlan that
> I have available... anyway, thanks for confirming.

Ah, yes, they don't support WDS maybe. Let me look if it's triggerable
differently. Here's what you can do: install the 'iw' tool (from
git.sipsolutions.net) and create a new interface:

# iw dev wmaster0 interface add wlan1 type station

then try to set it up:
# ifconfig wlan1 up
SIOCSIFFLAGS: Name not unique on network
# ip link set wlan1 up
#

> This command will uncover alot of places where error messages should
> likely be added:
> 
> 
> grep -R -A1 'if.*rtnl_' . | grep -B1 exit
> 
> 
> I'll have a look at it and send the patch upstream after my upcoming
> roadtrip, unless someone else has already beaten me to it by then.

Cool, thanks. I can talk to upstream, I know Stephen.

johannes
[signature.asc (application/pgp-signature, inline)]

Changed Bug title to `no error message when link up fails.' from `/sbin/ip: fails to check error codes'. Request was from Andreas Henriksson <andreas@fatal.se> to control@bugs.debian.org. (Wed, 16 Jul 2008 20:39:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #32 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: stephen.hemminger@vyatta.com
Cc: Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 00:00:58 +0200
Hi Stephen and co.!

Johannes Berg reported that iproute2 doesn't give any error message when
"ip link set ... up" failed for him (as opposed to ifconfig):
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=489340

The ways he suggested didn't work for me to reproduce, but I found out
simply using the wmaster0 device works as a testcase.
(You'll need a wireless device, probably with a driver based on the new
mac80211 stack).

I've debugged this into a place in the bundled rtnetlink library where
if there's a netlink error - it is ignored if there's no errno, which
seems weird. I don't really understand the code, but this "proof of
concept" patch makes "ip link set dev wmaster0 up" spit out an error
message atleast. Could you please have a look at what's going on here?


diff --git a/lib/libnetlink.c b/lib/libnetlink.c
index 5ae64f7..afa58fb 100644
--- a/lib/libnetlink.c
+++ b/lib/libnetlink.c
@@ -351,6 +351,7 @@ int rtnl_talk(struct rtnl_handle *rtnl, struct nlmsghdr *n, pid_t peer,
 					if (errno == 0) {
 						if (answer)
 							memcpy(answer, h, h->nlmsg_len);
+						fprintf(stderr, "Unknown netlink error.\n");
 						return 0;
 					}
 					perror("RTNETLINK answers");



For the record, here's what ifconfig says:

$ sudo ifconfig wmaster0 up
SIOCSIFFLAGS: Operation not supported


--
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Stephen Hemminger <shemminger@vyatta.com>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #37 received at 489340@bugs.debian.org (full text, mbox):

From: Stephen Hemminger <shemminger@vyatta.com>
To: Andreas Henriksson <andreas@fatal.se>
Cc: stephen.hemminger@vyatta.com, Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Wed, 16 Jul 2008 15:03:20 -0700
On Thu, 17 Jul 2008 00:00:58 +0200
Andreas Henriksson <andreas@fatal.se> wrote:

> Hi Stephen and co.!
> 
> Johannes Berg reported that iproute2 doesn't give any error message when
> "ip link set ... up" failed for him (as opposed to ifconfig):
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=489340
> 
> The ways he suggested didn't work for me to reproduce, but I found out
> simply using the wmaster0 device works as a testcase.
> (You'll need a wireless device, probably with a driver based on the new
> mac80211 stack).
> 
> I've debugged this into a place in the bundled rtnetlink library where
> if there's a netlink error - it is ignored if there's no errno, which
> seems weird. I don't really understand the code, but this "proof of
> concept" patch makes "ip link set dev wmaster0 up" spit out an error
> message atleast. Could you please have a look at what's going on here?
> 
> 
> diff --git a/lib/libnetlink.c b/lib/libnetlink.c
> index 5ae64f7..afa58fb 100644
> --- a/lib/libnetlink.c
> +++ b/lib/libnetlink.c
> @@ -351,6 +351,7 @@ int rtnl_talk(struct rtnl_handle *rtnl, struct nlmsghdr *n, pid_t peer,
>  					if (errno == 0) {
>  						if (answer)
>  							memcpy(answer, h, h->nlmsg_len);
> +						fprintf(stderr, "Unknown netlink error.\n");
>  						return 0;
>  					}
>  					perror("RTNETLINK answers");
> 
> 
> 
> For the record, here's what ifconfig says:
> 
> $ sudo ifconfig wmaster0 up
> SIOCSIFFLAGS: Operation not supported

libnetlink shouldn't print the error, it needs to be done by the caller.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #42 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: Stephen Hemminger <shemminger@vyatta.com>
Cc: stephen.hemminger@vyatta.com, Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 00:27:17 +0200
On ons, 2008-07-16 at 15:03 -0700, Stephen Hemminger wrote:
> On Thu, 17 Jul 2008 00:00:58 +0200
> Andreas Henriksson <andreas@fatal.se> wrote:
[...]
> > +						fprintf(stderr, "Unknown netlink error.\n");
> >  						return 0;
[..]
> libnetlink shouldn't print the error, it needs to be done by the caller.
... and iproute should exit with a proper error code. This isn't
possible today, as there's no way for the caller to detect the error!
I was just trying to be a bit helpful on where we end up in the code.

If anyone could help out with how to modify the code to solve all this,
that would be nice. I don't understand the current code tries to do.

(By the way, most uses of rtnl_* seems to be if (rtnl_* < 0) exit(1); in
iproute2 currently. The error messages are in libnetlink.)


-- 
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Stephen Hemminger <shemminger@vyatta.com>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #47 received at 489340@bugs.debian.org (full text, mbox):

From: Stephen Hemminger <shemminger@vyatta.com>
To: Andreas Henriksson <andreas@fatal.se>
Cc: stephen.hemminger@vyatta.com, Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Wed, 16 Jul 2008 15:26:31 -0700
On Thu, 17 Jul 2008 00:27:17 +0200
Andreas Henriksson <andreas@fatal.se> wrote:

> On ons, 2008-07-16 at 15:03 -0700, Stephen Hemminger wrote:
> > On Thu, 17 Jul 2008 00:00:58 +0200
> > Andreas Henriksson <andreas@fatal.se> wrote:
> [...]
> > > +						fprintf(stderr, "Unknown netlink error.\n");
> > >  						return 0;
> [..]
> > libnetlink shouldn't print the error, it needs to be done by the caller.
> ... and iproute should exit with a proper error code. This isn't
> possible today, as there's no way for the caller to detect the error!
> I was just trying to be a bit helpful on where we end up in the code.
> 
> If anyone could help out with how to modify the code to solve all this,
> that would be nice. I don't understand the current code tries to do.
> 
> (By the way, most uses of rtnl_* seems to be if (rtnl_* < 0) exit(1); in
> iproute2 currently. The error messages are in libnetlink.)
> 
> 

The problem is the driver is responding with an error packet but the
errno is 0. This looks like a kernel bug, not an library bug.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #52 received at 489340@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Stephen Hemminger <shemminger@vyatta.com>
Cc: Andreas Henriksson <andreas@fatal.se>, stephen.hemminger@vyatta.com, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 00:35:22 +0200
[Message part 1 (text/plain, inline)]
> > (By the way, most uses of rtnl_* seems to be if (rtnl_* < 0) exit(1); in
> > iproute2 currently. The error messages are in libnetlink.)

> The problem is the driver is responding with an error packet but the
> errno is 0. This looks like a kernel bug, not an library bug.

I don't think so, the recvmsg() call worked fine, but the message
indicates that the netlink consumer had an error. Or am I missing
something?

johannes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Stephen Hemminger <shemminger@vyatta.com>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #57 received at 489340@bugs.debian.org (full text, mbox):

From: Stephen Hemminger <shemminger@vyatta.com>
To: Johannes Berg <johannes@sipsolutions.net>
Cc: Andreas Henriksson <andreas@fatal.se>, stephen.hemminger@vyatta.com, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Wed, 16 Jul 2008 15:53:54 -0700
On Thu, 17 Jul 2008 00:35:22 +0200
Johannes Berg <johannes@sipsolutions.net> wrote:

> 
> > > (By the way, most uses of rtnl_* seems to be if (rtnl_* < 0) exit(1); in
> > > iproute2 currently. The error messages are in libnetlink.)
> 
> > The problem is the driver is responding with an error packet but the
> > errno is 0. This looks like a kernel bug, not an library bug.
> 
> I don't think so, the recvmsg() call worked fine, but the message
> indicates that the netlink consumer had an error. Or am I missing
> something?
> 
> johannes

The netlink message in question is marked as type ERROR but the errno
encoded in the message is zero.

		if (h->nlmsg_type == NLMSG_ERROR) {
			struct nlmsgerr *err = (struct nlmsgerr*)NLMSG_DATA(h);
			if (l < sizeof(struct nlmsgerr)) {
				fprintf(stderr, "ERROR truncated\n");
			} else {
				errno = -err->error;
				if (errno == 0) {
					if (answer)
						memcpy(answer, h, h->nlmsg_len);
					return 0;
				}
				perror("RTNETLINK answers");
			}

So the netlink library just treats as a successful return.
To me it looks like the problem is in the kernel sending back
a NLMSG_ERROR with errno of zero. Some code path isn't setting
it up properly.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #62 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: Stephen Hemminger <shemminger@vyatta.com>
Cc: Johannes Berg <johannes@sipsolutions.net>, stephen.hemminger@vyatta.com, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 02:31:00 +0200
On ons, 2008-07-16 at 15:53 -0700, Stephen Hemminger wrote:
> The netlink message in question is marked as type ERROR but the errno
> encoded in the message is zero.
> 
> 		if (h->nlmsg_type == NLMSG_ERROR) {
> 			struct nlmsgerr *err = (struct nlmsgerr*)NLMSG_DATA(h);
> 			if (l < sizeof(struct nlmsgerr)) {
> 				fprintf(stderr, "ERROR truncated\n");
> 			} else {
> 				errno = -err->error;
> 				if (errno == 0) {
> 					if (answer)
> 						memcpy(answer, h, h->nlmsg_len);
> 					return 0;
> 				}
> 				perror("RTNETLINK answers");
> 			}
> 
> So the netlink library just treats as a successful return.
Why? This seems like a really bad idea to me, and none of the callers in
iproute benefits from this as far as I can see.

Just ripping out the errno == 0 special casing looks like and option to
me, unless anyone can find a reason for it.
(It'll give an error message and an error exit code! The message will be
strange, but lets blame the kernel for that cosmetic issue. Atleast the
user got some kind of notification.)

Moving the "return 0;" inside the "if (answer)" would be another
(atleast for iproutes callers of the library functions)...

> To me it looks like the problem is in the kernel sending back
> a NLMSG_ERROR with errno of zero. Some code path isn't setting
> it up properly.

None the less, it would be be good if the application wouldn't poop it's
pants when it can be avoided - broken kernel or not.


diff --git a/lib/libnetlink.c b/lib/libnetlink.c
index 5ae64f7..4413165 100644
--- a/lib/libnetlink.c
+++ b/lib/libnetlink.c
@@ -348,12 +348,7 @@ int rtnl_talk(struct rtnl_handle *rtnl, struct nlmsghdr *n, pid_t peer,
 					fprintf(stderr, "ERROR truncated\n");
 				} else {
 					errno = -err->error;
-					if (errno == 0) {
-						if (answer)
-							memcpy(answer, h, h->nlmsg_len);
-						return 0;
-					}
-					perror("RTNETLINK answers");
+					perror("RTNETLINK error");
 				}
 				return -1;
 			}


-- 
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Patrick McHardy <kaber@trash.net>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #67 received at 489340@bugs.debian.org (full text, mbox):

From: Patrick McHardy <kaber@trash.net>
To: Andreas Henriksson <andreas@fatal.se>
Cc: Stephen Hemminger <shemminger@vyatta.com>, Johannes Berg <johannes@sipsolutions.net>, stephen.hemminger@vyatta.com, 489340@bugs.debian.org, netdev@vger.kernel.org, "David S. Miller" <davem@davemloft.net>
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 11:26:38 +0200
[Message part 1 (text/plain, inline)]
Andreas Henriksson wrote:
> On ons, 2008-07-16 at 15:53 -0700, Stephen Hemminger wrote:
>> The netlink message in question is marked as type ERROR but the errno
>> encoded in the message is zero.
>>
>> 		if (h->nlmsg_type == NLMSG_ERROR) {
>> 			struct nlmsgerr *err = (struct nlmsgerr*)NLMSG_DATA(h);
>> 			if (l < sizeof(struct nlmsgerr)) {
>> 				fprintf(stderr, "ERROR truncated\n");
>> 			} else {
>> 				errno = -err->error;
>> 				if (errno == 0) {
>> 					if (answer)
>> 						memcpy(answer, h, h->nlmsg_len);
>> 					return 0;
>> 				}
>> 				perror("RTNETLINK answers");
>> 			}
>>
>> So the netlink library just treats as a successful return.
> Why? This seems like a really bad idea to me, and none of the callers in
> iproute benefits from this as far as I can see.
> 
> Just ripping out the errno == 0 special casing looks like and option to
> me, unless anyone can find a reason for it.

NLMSG_ERROR with errno == 0 is a netlink ACK message.

> (It'll give an error message and an error exit code! The message will be
> strange, but lets blame the kernel for that cosmetic issue. Atleast the
> user got some kind of notification.)
> 
> Moving the "return 0;" inside the "if (answer)" would be another
> (atleast for iproutes callers of the library functions)...
> 
>> To me it looks like the problem is in the kernel sending back
>> a NLMSG_ERROR with errno of zero. Some code path isn't setting
>> it up properly.
> 
> None the less, it would be be good if the application wouldn't poop it's
> pants when it can be avoided - broken kernel or not.

The fix in this case is to propagate the return value from
dev_change_flags().


[x (text/plain, inline)]
rtnetlink: propagate error from dev_change_flags in do_setlink()

Andreas Henriksson <andreas@fatal.se> reported that unlike ifconfig,
iproute doesn't report an error when setting an interface up fails.

Propagate the return value from dev_change_flags() to fix this.

Signed-off-by: Patrick McHardy <kaber@trash.net>
diff --git a/net/core/rtnetlink.c b/net/core/rtnetlink.c
index a9a7721..ffde766 100644
--- a/net/core/rtnetlink.c
+++ b/net/core/rtnetlink.c
@@ -867,7 +867,9 @@ static int do_setlink(struct net_device *dev, struct ifinfomsg *ifm,
 		if (ifm->ifi_change)
 			flags = (flags & ifm->ifi_change) |
 				(dev->flags & ~ifm->ifi_change);
-		dev_change_flags(dev, flags);
+		err = dev_change_flags(dev, flags);
+		if (err < 0)
+			goto errout;
 	}
 
 	if (tb[IFLA_TXQLEN])

Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Jarek Poplawski <jarkao2@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #72 received at 489340@bugs.debian.org (full text, mbox):

From: Jarek Poplawski <jarkao2@gmail.com>
To: Patrick McHardy <kaber@trash.net>
Cc: Andreas Henriksson <andreas@fatal.se>, Stephen Hemminger <shemminger@vyatta.com>, Johannes Berg <johannes@sipsolutions.net>, stephen.hemminger@vyatta.com, 489340@bugs.debian.org, netdev@vger.kernel.org, "David S. Miller" <davem@davemloft.net>
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 09:59:45 +0000
On 17-07-2008 11:26, Patrick McHardy wrote:
...
> rtnetlink: propagate error from dev_change_flags in do_setlink()
> 
> Andreas Henriksson <andreas@fatal.se> reported that

+ Johannes Berg reported that

> unlike ifconfig,
> iproute doesn't report an error when setting an interface up fails.
> 
> Propagate the return value from dev_change_flags() to fix this.
> 
> Signed-off-by: Patrick McHardy <kaber@trash.net>

Jarek P.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to hadi@cyberus.ca:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #77 received at 489340@bugs.debian.org (full text, mbox):

From: jamal <hadi@cyberus.ca>
To: Andreas Henriksson <andreas@fatal.se>
Cc: Stephen Hemminger <shemminger@vyatta.com>, Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org, netdev@vger.kernel.org
Subject: Re: iproute2: no error message when link up command fails.
Date: Thu, 17 Jul 2008 06:31:54 -0400
On Thu, 2008-17-07 at 02:31 +0200, Andreas Henriksson wrote:

> Why? 

Thats just how it rolls.

> This seems like a really bad idea to me, and none of the callers in
> iproute benefits from this as far as I can see.

The receiver(kernel in this case, but it could be some other user space
user) returning a zero means success. Essentially zero is an (Positive)
ACK.
The receiver returning a non-zero implies a failure. Essentially a
N(egative) ACK. 

In the case of a NACK, the kernel must return you the original message
header you sent (similar to the way some icmp messages behave).
The returned error code is a standard errno - if you sent a bad config
you may get an EINVAL back. The sender combines the errno + the header
to figure out what went wrong.

Does that make sense? So the kernel fix is required (as Stephen noted).

cheers,
jamal





Information forwarded to debian-bugs-dist@lists.debian.org, Debian iproute maintainers <ah-iproute@debian.org>:
Bug#489340; Package iproute. Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian iproute maintainers <ah-iproute@debian.org>. Full text and rfc822 format available.

Message #82 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: control@bugs.debian.org
Cc: 489340@bugs.debian.org, linux-2.6@packages.debian.org
Subject: retitle 489340 to errno not propagated when link up fails., reassign 489340 to linux-2.6 ...
Date: Thu, 17 Jul 2008 22:48:34 +0200
# Automatically generated email from bts, devscripts version 2.10.34
retitle 489340 errno not propagated when link up fails.
reassign 489340 linux-2.6 
# see the attachment in the mail from Patrick McHardy.
tags 489340 + patch





Changed Bug title to `errno not propagated when link up fails.' from `no error message when link up fails.'. Request was from Andreas Henriksson <andreas@fatal.se> to control@bugs.debian.org. (Thu, 17 Jul 2008 20:48:03 GMT) Full text and rfc822 format available.

Bug reassigned from package `iproute' to `linux-2.6'. Request was from Andreas Henriksson <andreas@fatal.se> to control@bugs.debian.org. (Thu, 17 Jul 2008 20:48:04 GMT) Full text and rfc822 format available.

Tags added: patch Request was from Andreas Henriksson <andreas@fatal.se> to control@bugs.debian.org. (Thu, 17 Jul 2008 20:48:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#489340; Package linux-2.6. (Tue, 11 Nov 2008 18:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 11 Nov 2008 18:36:04 GMT) Full text and rfc822 format available.

Message #93 received at 489340@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Andreas Henriksson <andreas@fatal.se>
Cc: 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Tue, 11 Nov 2008 19:03:32 +0100
[Message part 1 (text/plain, inline)]
On Sat, 2008-07-05 at 14:19 +0200, Andreas Henriksson wrote:
> On lör, 2008-07-05 at 13:48 +0200, Johannes Berg wrote:
> > ip link set wlan0 down
> > iwconfig wlan0 mode repeater # set WDS mode but no peer address
> > ip link set wlan0 up
> 
> Unfortunately, this failed on both my atheros- and intel-based wlan that
> I have available... anyway, thanks for confirming.
> 
> This command will uncover alot of places where error messages should
> likely be added:
> 
> 
> grep -R -A1 'if.*rtnl_' . | grep -B1 exit
> 
> 
> I'll have a look at it and send the patch upstream after my upcoming
> roadtrip, unless someone else has already beaten me to it by then.

Did you get around to looking at this? I just ran into this again.

johannes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#489340; Package linux-2.6. (Tue, 11 Nov 2008 19:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 11 Nov 2008 19:03:08 GMT) Full text and rfc822 format available.

Message #98 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: Johannes Berg <johannes@sipsolutions.net>, 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Tue, 11 Nov 2008 20:05:16 +0100
On tis, 2008-11-11 at 19:03 +0100, Johannes Berg wrote:
> Did you get around to looking at this? I just ran into this again.

The conclusion was that it was a kernel problem. Patrick McHardy sent a
patch, but I guess it got lost and noone bothered to resend it...

http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=489340#67


-- 
Regards,
Andreas Henriksson




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#489340; Package linux-2.6. (Tue, 11 Nov 2008 21:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Johannes Berg <johannes@sipsolutions.net>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 11 Nov 2008 21:24:03 GMT) Full text and rfc822 format available.

Message #103 received at 489340@bugs.debian.org (full text, mbox):

From: Johannes Berg <johannes@sipsolutions.net>
To: Andreas Henriksson <andreas@fatal.se>
Cc: 489340@bugs.debian.org
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Tue, 11 Nov 2008 22:21:18 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2008-11-11 at 20:05 +0100, Andreas Henriksson wrote:
> On tis, 2008-11-11 at 19:03 +0100, Johannes Berg wrote:
> > Did you get around to looking at this? I just ran into this again.
> 
> The conclusion was that it was a kernel problem. Patrick McHardy sent a
> patch, but I guess it got lost and noone bothered to resend it...
> 
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=489340#67

Oops, I missed that, I'll take care of getting it into the kernel.

johannes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#489340; Package linux-2.6. (Mon, 17 Nov 2008 10:13:58 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Henriksson <andreas@fatal.se>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Mon, 17 Nov 2008 10:14:53 GMT) Full text and rfc822 format available.

Message #108 received at 489340@bugs.debian.org (full text, mbox):

From: Andreas Henriksson <andreas@fatal.se>
To: control@bugs.debian.org, 489340@bugs.debian.org
Cc: Johannes Berg <johannes@sipsolutions.net>
Subject: Re: Bug#489340: /sbin/ip: fails to check error codes
Date: Mon, 17 Nov 2008 10:56:53 +0100
[Message part 1 (text/plain, inline)]
tags 489340 + fixed-upstream
thanks

Thanks again Johannes! Tagging the bug....

On Mon, Nov 17, 2008 at 10:16:59AM +0100, Johannes Berg wrote:
> On Tue, 2008-11-11 at 22:31 +0100, Andreas Henriksson wrote:
> > On tis, 2008-11-11 at 22:21 +0100, Johannes Berg wrote:
> > > I'll take care of getting it into the kernel.
> > 
> > Great! Thanks!
> 
> Done.
> http://git.kernel.org/?p=linux/kernel/git/davem/net-2.6.git;a=commit;h=5f9021cfdc3524a4c5e3d7ae2d049eb7adcd6776
> 
> davem has also sent a pull request, so it'll end up in .28 soon, and
> it's being pushed into -stable too.
> 
> johannes



-- 
Andreas Henriksson
[signature.asc (application/pgp-signature, inline)]

Tags added: fixed-upstream Request was from Andreas Henriksson <andreas@fatal.se> to control@bugs.debian.org. (Mon, 17 Nov 2008 10:17:40 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Maximilian Attems <maks@alioth.debian.org> to control@bugs.debian.org. (Thu, 12 Feb 2009 22:36:04 GMT) Full text and rfc822 format available.

Reply sent to maximilian attems <maks@debian.org>:
You have taken responsibility. (Sat, 21 Feb 2009 11:00:03 GMT) Full text and rfc822 format available.

Notification sent to Johannes Berg <johannes@sipsolutions.net>:
Bug acknowledged by developer. (Sat, 21 Feb 2009 11:00:03 GMT) Full text and rfc822 format available.

Message #117 received at 489340-close@bugs.debian.org (full text, mbox):

From: maximilian attems <maks@debian.org>
To: 489340-close@bugs.debian.org
Subject: Bug#489340: fixed in linux-2.6 2.6.28-1
Date: Sat, 21 Feb 2009 10:25:19 +0000
Source: linux-2.6
Source-Version: 2.6.28-1

We believe that the bug you reported is fixed in the latest version of
linux-2.6, which is due to be installed in the Debian FTP archive:

linux-2.6_2.6.28-1.diff.gz
  to pool/main/l/linux-2.6/linux-2.6_2.6.28-1.diff.gz
linux-2.6_2.6.28-1.dsc
  to pool/main/l/linux-2.6/linux-2.6_2.6.28-1.dsc
linux-2.6_2.6.28.orig.tar.gz
  to pool/main/l/linux-2.6/linux-2.6_2.6.28.orig.tar.gz
linux-doc-2.6.28_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-doc-2.6.28_2.6.28-1_all.deb
linux-headers-2.6.28-1-all-amd64_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-headers-2.6.28-1-all-amd64_2.6.28-1_amd64.deb
linux-headers-2.6.28-1-all_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-headers-2.6.28-1-all_2.6.28-1_amd64.deb
linux-headers-2.6.28-1-amd64_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-headers-2.6.28-1-amd64_2.6.28-1_amd64.deb
linux-headers-2.6.28-1-common_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-headers-2.6.28-1-common_2.6.28-1_amd64.deb
linux-image-2.6.28-1-amd64_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-image-2.6.28-1-amd64_2.6.28-1_amd64.deb
linux-libc-dev_2.6.28-1_amd64.deb
  to pool/main/l/linux-2.6/linux-libc-dev_2.6.28-1_amd64.deb
linux-manual-2.6.28_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-manual-2.6.28_2.6.28-1_all.deb
linux-patch-debian-2.6.28_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-patch-debian-2.6.28_2.6.28-1_all.deb
linux-source-2.6.28_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-source-2.6.28_2.6.28-1_all.deb
linux-support-2.6.28-1_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-support-2.6.28-1_2.6.28-1_all.deb
linux-tree-2.6.28_2.6.28-1_all.deb
  to pool/main/l/linux-2.6/linux-tree-2.6.28_2.6.28-1_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 489340@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
maximilian attems <maks@debian.org> (supplier of updated linux-2.6 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 18 Feb 2009 16:36:04 +0100
Source: linux-2.6
Binary: linux-source-2.6.28 linux-doc-2.6.28 linux-manual-2.6.28 linux-patch-debian-2.6.28 linux-tree-2.6.28 linux-support-2.6.28-1 linux-libc-dev linux-headers-2.6.28-1-all linux-headers-2.6.28-1-all-alpha linux-headers-2.6.28-1-common linux-image-2.6.28-1-alpha-generic linux-headers-2.6.28-1-alpha-generic linux-image-2.6.28-1-alpha-smp linux-headers-2.6.28-1-alpha-smp linux-image-2.6.28-1-alpha-legacy linux-headers-2.6.28-1-alpha-legacy linux-headers-2.6.28-1-all-amd64 linux-image-2.6.28-1-amd64 linux-headers-2.6.28-1-amd64 linux-headers-2.6.28-1-all-arm linux-image-2.6.28-1-footbridge linux-headers-2.6.28-1-footbridge linux-image-2.6.28-1-iop32x linux-headers-2.6.28-1-iop32x linux-image-2.6.28-1-ixp4xx linux-headers-2.6.28-1-ixp4xx linux-image-2.6.28-1-orion5x linux-headers-2.6.28-1-orion5x linux-headers-2.6.28-1-all-armel linux-image-2.6.28-1-versatile linux-headers-2.6.28-1-versatile linux-headers-2.6.28-1-all-hppa linux-image-2.6.28-1-parisc linux-headers-2.6.28-1-parisc linux-image-2.6.28-1-parisc-smp linux-headers-2.6.28-1-parisc-smp linux-image-2.6.28-1-parisc64 linux-headers-2.6.28-1-parisc64 linux-image-2.6.28-1-parisc64-smp linux-headers-2.6.28-1-parisc64-smp linux-headers-2.6.28-1-all-i386 linux-image-2.6.28-1-486 linux-headers-2.6.28-1-486 linux-image-2.6.28-1-686 linux-headers-2.6.28-1-686 linux-image-2.6.28-1-686-bigmem linux-headers-2.6.28-1-686-bigmem linux-headers-2.6.28-1-all-ia64 linux-image-2.6.28-1-itanium linux-headers-2.6.28-1-itanium linux-image-2.6.28-1-mckinley linux-headers-2.6.28-1-mckinley linux-headers-2.6.28-1-all-m68k linux-image-2.6.28-1-amiga linux-headers-2.6.28-1-amiga linux-image-2.6.28-1-atari linux-headers-2.6.28-1-atari linux-image-2.6.28-1-bvme6000 linux-headers-2.6.28-1-bvme6000 linux-image-2.6.28-1-mac linux-headers-2.6.28-1-mac linux-image-2.6.28-1-mvme147 linux-headers-2.6.28-1-mvme147 linux-image-2.6.28-1-mvme16x linux-headers-2.6.28-1-mvme16x linux-headers-2.6.28-1-all-mips linux-image-2.6.28-1-r4k-ip22 linux-headers-2.6.28-1-r4k-ip22 linux-image-2.6.28-1-r5k-ip32 linux-headers-2.6.28-1-r5k-ip32 linux-image-2.6.28-1-sb1-bcm91250a linux-headers-2.6.28-1-sb1-bcm91250a linux-image-2.6.28-1-sb1a-bcm91480b linux-headers-2.6.28-1-sb1a-bcm91480b linux-image-2.6.28-1-4kc-malta linux-headers-2.6.28-1-4kc-malta linux-image-2.6.28-1-5kc-malta linux-headers-2.6.28-1-5kc-malta linux-headers-2.6.28-1-all-mipsel linux-image-2.6.28-1-r5k-cobalt linux-headers-2.6.28-1-r5k-cobalt linux-headers-2.6.28-1-all-powerpc linux-image-2.6.28-1-powerpc linux-headers-2.6.28-1-powerpc linux-image-2.6.28-1-powerpc-smp linux-headers-2.6.28-1-powerpc-smp linux-image-2.6.28-1-powerpc64 linux-headers-2.6.28-1-powerpc64 linux-headers-2.6.28-1-all-s390 linux-image-2.6.28-1-s390 linux-headers-2.6.28-1-s390 linux-image-2.6.28-1-s390-tape linux-image-2.6.28-1-s390x linux-headers-2.6.28-1-s390x linux-headers-2.6.28-1-all-sparc linux-image-2.6.28-1-sparc64 linux-headers-2.6.28-1-sparc64 linux-image-2.6.28-1-sparc64-smp linux-headers-2.6.28-1-sparc64-smp
Architecture: source all amd64
Version: 2.6.28-1
Distribution: unstable
Urgency: low
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Changed-By: maximilian attems <maks@debian.org>
Description: 
 linux-doc-2.6.28 - Linux kernel specific documentation for version 2.6.28
 linux-headers-2.6.28-1-486 - Header files for Linux 2.6.28-1-486
 linux-headers-2.6.28-1-4kc-malta - Header files for Linux 2.6.28-1-4kc-malta
 linux-headers-2.6.28-1-5kc-malta - Header files for Linux 2.6.28-1-5kc-malta
 linux-headers-2.6.28-1-686 - Header files for Linux 2.6.28-1-686
 linux-headers-2.6.28-1-686-bigmem - Header files for Linux 2.6.28-1-686-bigmem
 linux-headers-2.6.28-1-all - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-alpha - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-amd64 - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-arm - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-armel - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-hppa - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-i386 - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-ia64 - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-m68k - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-mips - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-mipsel - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-powerpc - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-s390 - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-all-sparc - All header files for Linux 2.6.28
 linux-headers-2.6.28-1-alpha-generic - Header files for Linux 2.6.28-1-alpha-generic
 linux-headers-2.6.28-1-alpha-legacy - Header files for Linux 2.6.28-1-alpha-legacy
 linux-headers-2.6.28-1-alpha-smp - Header files for Linux 2.6.28-1-alpha-smp
 linux-headers-2.6.28-1-amd64 - Header files for Linux 2.6.28-1-amd64
 linux-headers-2.6.28-1-amiga - Header files for Linux 2.6.28-1-amiga
 linux-headers-2.6.28-1-atari - Header files for Linux 2.6.28-1-atari
 linux-headers-2.6.28-1-bvme6000 - Header files for Linux 2.6.28-1-bvme6000
 linux-headers-2.6.28-1-common - Common header files for Linux 2.6.28-1
 linux-headers-2.6.28-1-footbridge - Header files for Linux 2.6.28-1-footbridge
 linux-headers-2.6.28-1-iop32x - Header files for Linux 2.6.28-1-iop32x
 linux-headers-2.6.28-1-itanium - Header files for Linux 2.6.28-1-itanium
 linux-headers-2.6.28-1-ixp4xx - Header files for Linux 2.6.28-1-ixp4xx
 linux-headers-2.6.28-1-mac - Header files for Linux 2.6.28-1-mac
 linux-headers-2.6.28-1-mckinley - Header files for Linux 2.6.28-1-mckinley
 linux-headers-2.6.28-1-mvme147 - Header files for Linux 2.6.28-1-mvme147
 linux-headers-2.6.28-1-mvme16x - Header files for Linux 2.6.28-1-mvme16x
 linux-headers-2.6.28-1-orion5x - Header files for Linux 2.6.28-1-orion5x
 linux-headers-2.6.28-1-parisc - Header files for Linux 2.6.28-1-parisc
 linux-headers-2.6.28-1-parisc-smp - Header files for Linux 2.6.28-1-parisc-smp
 linux-headers-2.6.28-1-parisc64 - Header files for Linux 2.6.28-1-parisc64
 linux-headers-2.6.28-1-parisc64-smp - Header files for Linux 2.6.28-1-parisc64-smp
 linux-headers-2.6.28-1-powerpc - Header files for Linux 2.6.28-1-powerpc
 linux-headers-2.6.28-1-powerpc-smp - Header files for Linux 2.6.28-1-powerpc-smp
 linux-headers-2.6.28-1-powerpc64 - Header files for Linux 2.6.28-1-powerpc64
 linux-headers-2.6.28-1-r4k-ip22 - Header files for Linux 2.6.28-1-r4k-ip22
 linux-headers-2.6.28-1-r5k-cobalt - Header files for Linux 2.6.28-1-r5k-cobalt
 linux-headers-2.6.28-1-r5k-ip32 - Header files for Linux 2.6.28-1-r5k-ip32
 linux-headers-2.6.28-1-s390 - Header files for Linux 2.6.28-1-s390
 linux-headers-2.6.28-1-s390x - Header files for Linux 2.6.28-1-s390x
 linux-headers-2.6.28-1-sb1-bcm91250a - Header files for Linux 2.6.28-1-sb1-bcm91250a
 linux-headers-2.6.28-1-sb1a-bcm91480b - Header files for Linux 2.6.28-1-sb1a-bcm91480b
 linux-headers-2.6.28-1-sparc64 - Header files for Linux 2.6.28-1-sparc64
 linux-headers-2.6.28-1-sparc64-smp - Header files for Linux 2.6.28-1-sparc64-smp
 linux-headers-2.6.28-1-versatile - Header files for Linux 2.6.28-1-versatile
 linux-image-2.6.28-1-486 - Linux 2.6.28 image on x86
 linux-image-2.6.28-1-4kc-malta - Linux 2.6.28 image on MIPS Malta
 linux-image-2.6.28-1-5kc-malta - Linux 2.6.28 image on MIPS Malta (64-bit)
 linux-image-2.6.28-1-686 - Linux 2.6.28 image on PPro/Celeron/PII/PIII/P4
 linux-image-2.6.28-1-686-bigmem - Linux 2.6.28 image on PPro/Celeron/PII/PIII/P4
 linux-image-2.6.28-1-alpha-generic - Linux 2.6.28 image on Alpha
 linux-image-2.6.28-1-alpha-legacy - Linux 2.6.28 image on Alpha Legacy
 linux-image-2.6.28-1-alpha-smp - Linux 2.6.28 image on Alpha SMP
 linux-image-2.6.28-1-amd64 - Linux 2.6.28 image on AMD64
 linux-image-2.6.28-1-amiga - Linux 2.6.28 image on Amiga
 linux-image-2.6.28-1-atari - Linux 2.6.28 image on Atari
 linux-image-2.6.28-1-bvme6000 - Linux 2.6.28 image on BVM BVME4000 and BVME6000
 linux-image-2.6.28-1-footbridge - Linux 2.6.28 image on Footbridge
 linux-image-2.6.28-1-iop32x - Linux 2.6.28 image on IOP32x
 linux-image-2.6.28-1-itanium - Linux 2.6.28 image on Itanium
 linux-image-2.6.28-1-ixp4xx - Linux 2.6.28 image on IXP4xx
 linux-image-2.6.28-1-mac - Linux 2.6.28 image on Macintosh
 linux-image-2.6.28-1-mckinley - Linux 2.6.28 image on Itanium II
 linux-image-2.6.28-1-mvme147 - Linux 2.6.28 image on Motorola MVME147
 linux-image-2.6.28-1-mvme16x - Linux 2.6.28 image on Motorola MVME162/6/7, MVME172/7
 linux-image-2.6.28-1-orion5x - Linux 2.6.28 image on Orion
 linux-image-2.6.28-1-parisc - Linux 2.6.28 image on 32-bit PA-RISC
 linux-image-2.6.28-1-parisc-smp - Linux 2.6.28 image on multiprocessor 32-bit PA-RISC
 linux-image-2.6.28-1-parisc64 - Linux 2.6.28 image on 64-bit PA-RISC
 linux-image-2.6.28-1-parisc64-smp - Linux 2.6.28 image on multiprocessor 64-bit PA-RISC
 linux-image-2.6.28-1-powerpc - Linux 2.6.28 image on uniprocessor 32-bit PowerPC
 linux-image-2.6.28-1-powerpc-smp - Linux 2.6.28 image on multiprocessor 32-bit PowerPC
 linux-image-2.6.28-1-powerpc64 - Linux 2.6.28 image on 64-bit PowerPC
 linux-image-2.6.28-1-r4k-ip22 - Linux 2.6.28 image on SGI IP22
 linux-image-2.6.28-1-r5k-cobalt - Linux 2.6.28 image on Cobalt
 linux-image-2.6.28-1-r5k-ip32 - Linux 2.6.28 image on SGI IP32
 linux-image-2.6.28-1-s390 - Linux 2.6.28 image on IBM S/390
 linux-image-2.6.28-1-s390-tape - Linux 2.6.28 image on IBM S/390, IPL from tape
 linux-image-2.6.28-1-s390x - Linux 2.6.28 image on IBM zSeries
 linux-image-2.6.28-1-sb1-bcm91250a - Linux 2.6.28 image on BCM91250A
 linux-image-2.6.28-1-sb1a-bcm91480b - Linux 2.6.28 image on BCM91480B
 linux-image-2.6.28-1-sparc64 - Linux 2.6.28 image on uniprocessor 64-bit UltraSPARC
 linux-image-2.6.28-1-sparc64-smp - Linux 2.6.28 image on multiprocessor 64-bit UltraSPARC
 linux-image-2.6.28-1-versatile - Linux 2.6.28 image on Versatile
 linux-libc-dev - Linux support headers for userspace development
 linux-manual-2.6.28 - Linux kernel API manual pages for version 2.6.28
 linux-patch-debian-2.6.28 - Debian patches to version 2.6.28 of the Linux kernel
 linux-source-2.6.28 - Linux kernel source for version 2.6.28 with Debian patches
 linux-support-2.6.28-1 - Support files for Linux 2.6.28
 linux-tree-2.6.28 - Linux kernel source tree for building Debian kernel images
Closes: 432877 456219 456219 463295 475319 487103 487725 489340 491309 494010 495590 495697 500065 501157 502663 502665 503688 504611 505184 507150 509979 512266 513228 513604
Changes: 
 linux-2.6 (2.6.28-1) unstable; urgency=low
 .
   * New upstream release
     - new btusb. (closes: #505184)
     - iwlagn driver for Intel Wifi Link 5100 and 5300. (closes: #501157)
     - drm git branch vblank-rework merged. (closes: #456219)
     - netfilter.h got in.h include. (closes: #487103)
     - netlink errno propageted. (closes: #489340)
     - agp g41 support (closes: #513228)
     - Includes atl2 driver (Closes: #500065)
     - Fixes loading of video module on Samsung systems
       (Closes: #475319, #495697)
     - Fix rf_kill handling of iwl3945 driver (Closes: #503688)
     - Fix adjtimex frequency offset (Closes: #432877)
     - Fix oopses with Canon PIXMA MP150 (Closes: #487725)
     - Fix excessive interrrupts with compiz (Closes: #456219)
     - dsp56k: use request_firmware and firmware nuked (closes: #494010)
     - dabusb: use request_firmware and firmware nuked (closes: #502663)
     - kaweth: use request_firmware and firmware nuked (closes: #502665)
 .
   [ maximilian attems ]
   * Reenable new Juju firewire stack.
   * topconfig set ATH9K, IWL5000, IP_NF_SECURITY, IP6_NF_SECURITY,
     BRIDGE_EBT_IP6, BT_HCIBTUSB, TOUCHSCREEN_INEXIO, TOUCHSCREEN_TOUCHIT213,
     VIRTIO_CONSOLE, VIDEO_ZORAN_ZR36060, USB_VIDEO_CLASS_INPUT_EVDEV,
     USB_GSPCA, USB_S2255, OCFS2_FS_STATS, OMFS_FS, CRYPTO_RMD128,
     CRYPTO_RMD160, CRYPTO_RMD256, CRYPTO_RMD320, VLAN_8021Q_GVRP, HP_WMI,
     COMPAL_LAPTOP, SCSI_DH, SCSI_DH_RDAC, SCSI_DH_HP_SW, SCSI_DH_EMC,
     SCSI_DH_ALUA, MAC80211_HWSIM, USB_HSO, BLK_DEV_INTEGRITY, SGI_XP, SGI_GRU,
     TLAN, ATM_IA, ATM_FORE200E, MISDN, I2C_HELPER_AUTO, I2C_ISCH,
     I2C_NFORCE2_S4985, AT24, SENSORS_AD7414, SENSORS_ADCXX,
     SOC_CAMERA_PLATFORM, VIDEO_SH_MOBILE_CEU, DVB_USB_DW2102, DVB_USB_ANYSEE,
     DVB_SIANO_SMS1XXX, DVB_DRX397XD, MMC_SDHCI_PCI (closes: #507150),
     MMC_SDRICOH_CS (closes: #509979), EDAC_I5100, RTC_DRV_M41T94,
     RTC_DRV_DS1305, UBIFS, EXT4 (closes: #512266), CGROUP_FREEZER,
     NETFILTER_TPROXY, NETFILTER_XT_TARGET_TPROXY, NETFILTER_XT_MATCH_RECENT,
     NETFILTER_XT_MATCH_SOCKET, NET_ACT_SKBEDIT, PHONET, NET_9P_RDMA, ATL2, JME,
     ENIC, MLX4_EN, USB_NET_SMSC95XX, I7300_IDLE, NET_SCH_MULTIQ, ICS932S401,
     PANASONIC_LAPTOP, QLGE, LIBERTAS_THINFIRM, LIBERTAS_THINFIRM_USB,
     INPUT_CM109, W1_SLAVE_BQ27000, SENSORS_ADT7462, SENSORS_MAX1111,
     SENSORS_LIS3LV02D, MFD_WM8400, MFD_WM8350_I2C, SOC_CAMERA_MT9M111,
     USB_M5602, USB_GSPCA_CONEX, USB_GSPCA_ETOMS, USB_GSPCA_FINEPIX,
     USB_GSPCA_MARS, USB_GSPCA_OV519, USB_GSPCA_PAC207, USB_GSPCA_PAC7311,
     USB_GSPCA_SONIXB, USB_GSPCA_SONIXJ, USB_GSPCA_SPCA500, USB_GSPCA_SPCA501,
     USB_GSPCA_SPCA505, USB_GSPCA_SPCA506, USB_GSPCA_SPCA508, USB_GSPCA_SPCA561,
     USB_GSPCA_STK014, USB_GSPCA_SUNPLUS, USB_GSPCA_T613, USB_GSPCA_TV8532,
     USB_GSPCA_VC032X, USB_GSPCA_ZC3XX, C2PORT, C2PORT_DURAMAR_2150,
     W83697UG_WDT, USB_MR800, DVB_USB_CINERGY_T2, DVB_USB_DTV5100,
     DVB_USB_AF9015, DVB_DM1105, DVB_LGS8GL5, DVB_DUMMY_FE,
     SND_HDA_CODEC_NVHDMI, SND_USB_US122L, USB_VST, LEDS_PCA9532, LEDS_HP_DISK,
     LEDS_PCA955X, LEDS_TRIGGER_BACKLIGHT, EDAC_X38, RTC_DRV_RX8581,
     RTC_DRV_DS1390, RTC_DRV_DS3234, RTC_DRV_DS1286, RTC_DRV_M48T35,
     RTC_DRV_BQ4802, RTC_DRV_WM8350, UNEVICTABLE_LRU, MAC80211_RC_MINSTREL,
     BATTERY_BQ27x00, REGULATOR, REGULATOR_BQ24022, REGULATOR_WM8350,
     REGULATOR_WM8400, FB_VIA, FB_METRONOME, FB_MB862XX, UIO_SERCOS3,
     CORE_DUMP_DEFAULT_ELF_HEADERS, NET_DSA, NET_DSA_MV88E6060,
     NET_DSA_MV88E6131, NET_DSA_MV88E6123_61_65, IT87_WDT,
     BACKLIGHT_MBP_NVIDIA, SND_HDA_INPUT_BEEP, USB_WUSB, USB_TMC, IDE_GD,
     IDE_GD_ATA, IDE_GD_ATAPI, PCMCIA_IBMTR, USB_EMI62, USB_EMI26, USB_SEVSEG,
     UWB, UWB_WLP, UWB_I1480U, UWB_I1480U_WLP, CRYPTO_FIPS, ANSI_CPRNG,
     CRC_T10DIF, STAGING, ET131X, CRYPTO_ANSI_CPRNG, PRISM2_USB, HID_COMPAT,
     SYSCTL_SYSCALL_CHECK, BOOT_TRACER.
   * [x86] set MOUSE_BCM5974, X86_RESERVE_LOW_64K, OPROFILE_IBS,
     MICROCODE_INTEL, MICROCODE_AMD, X86_VERBOSE_BOOTUP, MTRR_SANITIZER,
     CRYPTO_CRC32C_INTEL, STRICT_DEVMEM.
   * [x86_64] set AMD_IOMMU, INTR_REMAP.
   * [x86_32] set TOUCHSCREEN_HTCPEN, MOUSE_PS2_OLPC.
   * Add stable releases 2.6.28.1-6.
   * Turn off SYSFS_DEPRECATED* for newer udev and proper /sys/.
   * linux-libc-dev: Add versioned replaces libdrm-dev. (closes: #513604)
   * topconfig: Enable MACVLAN. (closes: #504611)
   * [ppc] BAYCOM_PAR, BAYCOM_EPP.
   * [x86_64] set NR_CPUS to 512. (closes: #491309)
   * [686-bigmem] set modular XEN_FBDEV_FRONTEND.
   * Newer Standards-Version 3.8.0 without changes.
   * Use update-initramfs for initramfs-tools.
   * Fix preinst and postinst call to not use deprecated mkinitramfs-kpkg
     interfaces.
 .
   [ Martin Michlmayr ]
   * [mips/r4k-ip22, mips/sb1-bcm91250a] Don't build in ISO9660.
   * [mipsel/r5k-cobalt] Enable INPUT_COBALT_BTNS.
   * [mipsel/r5k-cobalt] Enable the new Cobalt LCD driver (FB_COBALT).
   * [mips/r4k-ip22] Enable the new ALSA sound driver (SND_SGI_HAL2).
   * [arm/iop32x, arm/ixp4xx] Don't build in KEYBOARD_ATKBD, MOUSE_PS2,
     SERIO, JFFS2_FS, and CRAMFS.
   * [arm/iop32x, arm/ixp4xx] Unset DEBUG_KERNEL so the kernel will
     fit in flash.
   * [arm/orion5x] Unset FIXED_PHY to work around a clash with fixed
     mdio bus and mv643xx_eth.
   * Migrate arm, armel, mips and mipsel away from kernel-package.
 .
   [ Ian Campbell ]
   * [x86]: Enable Xen guest support in amd64 flavour. (closes: #495590)
 .
   [ dann frazier ]
   * [x86, ia64] Enable ACPI_PCI_SLOT
 .
   [ Bastian Blank ]
   * Make gcc-4.3 the default compiler. (closes: #463295)
   * Add optional image size check.
   * debian/rules.real: Setup image installation rules for alpha, hppa,
     ia64 and sparc.
   * Remove support to build images using kernel-package.
Checksums-Sha1: 
 d6521d80a29d30d21ad7c90d951ba5b5cccccd0e 4492 linux-2.6_2.6.28-1.dsc
 34e60478828100b34743ade432bada348d9f22a6 66112003 linux-2.6_2.6.28.orig.tar.gz
 30dd866c3004c776f243043df6a83c2cf5c580a6 1867755 linux-2.6_2.6.28-1.diff.gz
 1884422d35f55713b837be0abe18f5e8e7cb43fd 5104882 linux-doc-2.6.28_2.6.28-1_all.deb
 e2d4f59b5d92a3cdccb8402a1170951b7700e7c4 1900174 linux-manual-2.6.28_2.6.28-1_all.deb
 3e14dad65b1c897debbb6f2b4997e450b6cc05a0 1405006 linux-patch-debian-2.6.28_2.6.28-1_all.deb
 2be9a2760c72bac4504b8aa501a711d1cc6fe153 52494824 linux-source-2.6.28_2.6.28-1_all.deb
 074ab0abf3cbea80bcf8c60294a900676671985b 117694 linux-support-2.6.28-1_2.6.28-1_all.deb
 28de1c2a1716dc22697e94674a8dccfb2a13be73 102340 linux-tree-2.6.28_2.6.28-1_all.deb
 50529d63adc4b5311ac3aee342d22f75ceee16db 24516938 linux-image-2.6.28-1-amd64_2.6.28-1_amd64.deb
 11bdc3c359a34aa98e84db35f07808471dc74daa 721174 linux-headers-2.6.28-1-amd64_2.6.28-1_amd64.deb
 ba6901c4e22ea049181619d33ba26b1df7429d97 3822730 linux-headers-2.6.28-1-common_2.6.28-1_amd64.deb
 217bbcf36ac7d7dbd22ffe0ec1fb1ca2cc494891 101984 linux-headers-2.6.28-1-all_2.6.28-1_amd64.deb
 57f4c10e7d2be2d8b95c93daac5c1e8c3edf2cd7 101990 linux-headers-2.6.28-1-all-amd64_2.6.28-1_amd64.deb
 f740670d797f0153af6a46500568004629bbb9e9 816834 linux-libc-dev_2.6.28-1_amd64.deb
Checksums-Sha256: 
 cac4c6470e46f2d71356aa4a3f3736a059fb09066b9346cbe44d504b3f559b92 4492 linux-2.6_2.6.28-1.dsc
 8aaf2517cab1b719441665a56aa094a439c473e0af6b6fcb952948c961ab1a34 66112003 linux-2.6_2.6.28.orig.tar.gz
 7c11e71ac4133b570d4ee9ae59734c7e26f6775083f526f924b0152ca0338ef2 1867755 linux-2.6_2.6.28-1.diff.gz
 bfeee42118f57ac6062cd8c481d60d148caa70630c4d33040226b45607302c2b 5104882 linux-doc-2.6.28_2.6.28-1_all.deb
 5ccad3d4cab95fe46b2e544345b39d91f214b4e9aaaa70d5102aa0df7fd9c5c2 1900174 linux-manual-2.6.28_2.6.28-1_all.deb
 56bc0af7c107d2ff07ae94a7d535518506b47f8cc678adc3aef3cd7bb4c5f624 1405006 linux-patch-debian-2.6.28_2.6.28-1_all.deb
 756316b0e961e1849d7e2af3522ade6c9ed098a8f0e3851b8bfa877383534917 52494824 linux-source-2.6.28_2.6.28-1_all.deb
 9278b7c7dfb31505c5ecdb39aa71dd323a26318217cc441443230c22d74df86d 117694 linux-support-2.6.28-1_2.6.28-1_all.deb
 cfa7c78c49329fe7f3ec4836107a63de7705e0367b67403be728a7ef4c1fb3b5 102340 linux-tree-2.6.28_2.6.28-1_all.deb
 637f63058da5e3bdd3b530359349b05e1a35784f44ccd11d44d8cb1679dd62a5 24516938 linux-image-2.6.28-1-amd64_2.6.28-1_amd64.deb
 44e4927385b48b1786da94375430fed6993b5460ef9b50cef760d6c779edbaa9 721174 linux-headers-2.6.28-1-amd64_2.6.28-1_amd64.deb
 edfa47cc9670faa1dee1a07094f847014d73a6824db957281bee075a4685fa6e 3822730 linux-headers-2.6.28-1-common_2.6.28-1_amd64.deb
 93ed2fde22abe5e899e5752bea043da822069c6884c86c411bddf56bdb49ccd7 101984 linux-headers-2.6.28-1-all_2.6.28-1_amd64.deb
 aae7129fb668686086f1d5909dd439c04101665fb0157a04134182e5a64b1e53 101990 linux-headers-2.6.28-1-all-amd64_2.6.28-1_amd64.deb
 98c4715f95c76330efd980d8782a8cb12aefac240f376df6b524e107365cac4a 816834 linux-libc-dev_2.6.28-1_amd64.deb
Files: 
 4cb5c1b7176220fc1a32a69d0045adf2 4492 devel optional linux-2.6_2.6.28-1.dsc
 b54236c291a8e94c7535eda87058bad7 66112003 devel optional linux-2.6_2.6.28.orig.tar.gz
 021fe5b984c61a8749f308633bfd5051 1867755 devel optional linux-2.6_2.6.28-1.diff.gz
 128a99a0c86cc78298df127d72a23277 5104882 doc optional linux-doc-2.6.28_2.6.28-1_all.deb
 4b2fa55c06a077aa3640bdf6f313d14e 1900174 doc optional linux-manual-2.6.28_2.6.28-1_all.deb
 defff68cffe168cdcbe0975131f78e25 1405006 devel optional linux-patch-debian-2.6.28_2.6.28-1_all.deb
 be0d9f0f1d9b06a36acf4c034ba6c3d5 52494824 devel optional linux-source-2.6.28_2.6.28-1_all.deb
 3a40d9020b0eb83c8d493434ec02cd63 117694 devel optional linux-support-2.6.28-1_2.6.28-1_all.deb
 cc2982dc41e0e30c29b6386192fc416d 102340 devel optional linux-tree-2.6.28_2.6.28-1_all.deb
 a6579fff41a542647713400667fe183b 24516938 admin optional linux-image-2.6.28-1-amd64_2.6.28-1_amd64.deb
 0e3bfcfa8c7faad21549b2a6ed84d05e 721174 devel optional linux-headers-2.6.28-1-amd64_2.6.28-1_amd64.deb
 9e3f14c231f3a39d523a2d35fe4b4600 3822730 devel optional linux-headers-2.6.28-1-common_2.6.28-1_amd64.deb
 8c3cbe44a3927d6306a5ae1e3bc96250 101984 devel optional linux-headers-2.6.28-1-all_2.6.28-1_amd64.deb
 6ccb78fe8eb83588978addb5df76f253 101990 devel optional linux-headers-2.6.28-1-all-amd64_2.6.28-1_amd64.deb
 3414c4b8c88668412f3bf700473771d0 816834 devel optional linux-libc-dev_2.6.28-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkmcTnUACgkQeW7Lc5tEHqiL4wCgvElk+tw0mmI0eAQ3zRKaP506
5A0An0/3bQTrosyxtHgv+51IVP3YPmIK
=w5Ms
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 22 Mar 2009 07:29:41 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:58:39 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.